    var lastLine=0;
    var HTMLColors = {
         AliceBlue: '#F0F8FF',
         AntiqueWhite: '#FAEBD7',
         Aqua: '#00FFFF',
         Aquamarine: '#7FFFD4',
         Azure: '#F0FFFF',
         Beige: '#F5F5DC',
         Bisque: '#FFE4C4', 
         Black: '#000000', 
         BlanchedAlmond: '#FFEBCD', 
         Blue: '#0000FF',
         BlueViolet: '#8A2BE2',
         Brown: '#A52A2A',
         BurlyWood: '#DEB887',
         CadetBlue: '#5F9EA0',
         Chartreuse: '#7FFF00',
         Chocolate: '#D2691E',
         Coral: '#FF7F50',
         CornflowerBlue: '#6495ED',
         Cornsilk: '#FFF8DC',
         Crimson: '#DC143C',
         Cyan: '#00FFFF',
         DarkBlue: '#00008B',
         DarkCyan: '#008B8B',
         DarkGoldenrod: '#B8860B',
         DarkGray: '#A9A9A9',
         DarkGreen: '#006400',
         DarkKhaki: '#BDB76B',
         DarkMagenta: '#8B008B',
         DarkOliveGreen: '#556B2F',
         DarkOrange: '#FF8C00',
         DarkOrchid: '#9932CC',
         DarkRed: '#8B0000',
         DarkSalmon: '#E9967A',
         DarkSeaGreen: '#8FBC8F',
         DarkSlateBlue: '#483D8B',
         DarkSlateGray: '#2F4F4F',
         DarkTurquoise: '#00CED1',
         DarkViolet: '#9400D3',
         DeepPink: '#FF1493',
         DeepSkyBlue: '#00BFFF',
         DimGray: '#696969',
         DodgerBlue: '#1E90FF',
         FireBrick: '#B22222',
         FloralWhite: '#FFFAF0',
         ForestGreen: '#228B22',
         Fuchsia: '#FF00FF',
         Gainsboro: '#DCDCDC',
         GhostWhite: '#F8F8FF',
         Gold: '#FFD700',
         Goldenrod: '#DAA520',
         Gray: '#808080',
         Green: '#008000',
         GreenYellow: '#ADFF2F',
         Honeydew: '#F0FFF0',
         HotPink: '#FF69B4',
         IndianRed: '#CD5C5C',
         Indigo: '#4B0082',
         Ivory: '#FFFFF0',
         Khaki: '#F0E68C',
         Lavender: '#E6E6FA',
         LavenderBlush: '#FFF0F5',
         LawnGreen: '#7CFC00',
         LemonChiffon: '#FFFACD',
         LightBlue: '#ADD8E6',
         LightCoral: '#F08080',
         LightCyan: '#E0FFFF',
         LightGoldenrodYellow: '#FAFAD2',
         LightGreen: '#90EE90',
         LightGrey: '#D3D3D3',
         LightPink: '#FFB6C1',
         LightSalmon: '#FFA07A',
         LightSeaGreen: '#20B2AA',
         LightSkyBlue: '#87CEFA',
         LightSlateGray: '#778899',
         LightSteelBlue: '#B0C4DE',
         LightYellow: '#FFFFE0',
         Lime: '#00FF00',
         LimeGreen: '#32CD32',
         Linen: '#FAF0E6',
         Magenta: '#FF00FF',
         Maroon: '#800000',
         MediumAquamarine: '#66CDAA',
         MediumBlue: '#0000CD',
         MediumOrchid: '#BA55D3',
         MediumPurple: '#9370DB',
         MediumSeaGreen: '#3CB371',
         MediumSlateBlue: '#7B68EE',
         MediumSpringGreen: '#00FA9A',
         MediumTurquoise: '#48D1CC',
         MediumVioletRed: '#C71585',
         MidnightBlue: '#191970',
         MintCream: '#F5FFFA',
         MistyRose: '#FFE4E1',
         Moccasin: '#FFE4B5',
         NavajoWhite: '#FFDEAD',
         Navy: '#000080',
         OldLace: '#FDF5E6',
         Olive: '#808000',
         OliveDrab: '#6B8E23',
         Orange: '#FFA500',
         OrangeRed: '#FF4500',
         Orchid: '#DA70D6',
         PaleGoldenrod: '#EEE8AA',
         PaleGreen: '#98FB98',
         PaleTurquoise: '#AFEEEE',
         PaleVioletRed: '#DB7093',
         PapayaWhip: '#FFEFD5',
         PeachPuff: '#FFDAB9',
         Peru: '#CD853F',
         Pink: '#FFC0CB',
         Plum: '#DDA0DD',
         PowderBlue: '#B0E0E6',
         Purple: '#800080',
         Red: '#FF0000',
         RosyBrown: '#BC8F8F',
         RoyalBlue: '#4169E1',
         SaddleBrown: '#8B4513',
         Salmon: '#FA8072',
         SandyBrown: '#F4A460',
         SeaGreen: '#2E8B57',
         Seashell: '#FFF5EE',
         Sienna: '#A0522D',
         Silver: '#C0C0C0',
         SkyBlue: '#87CEEB',
         SlateBlue: '#6A5ACD',
         SlateGray: '#708090',
         Snow: '#FFFAFA',
         SpringGreen: '#00FF7F',
         SteelBlue: '#4682B4',
         Tan: '#D2B48C',
         Teal: '#008080',
         Thistle: '#D8BFD8',
         Tomato: '#FF6347',
         Turquoise: '#40E0D0',
         Violet: '#EE82EE',
         Wheat: '#F5DEB3',
         White: '#FFFFFF',
         WhiteSmoke: '#F5F5F5',
         Yellow: '#FFFF00',
         YellowGreen: '#9ACD32'
    };

    function getComputedCSSValue(el, prop) {
        if (prop=="float") { prop="cssFloat"; }
        try {
            return getComputedStyle(el)[prop];
        } catch (ex) {
            var curStyle = el.currentStyle;
            if (prop == "cssFloat") { prop = "styleFloat"; }
            var value = curStyle[prop];
            if (value) {
                value = [value].join('');
                if (value == "auto") {
                    switch (prop) {
                        case "width": 
                            var w = el.clientWidth;
                            /*w -= parseInt(getComputedCSSValue(el,'borderLeftWidth'));
                            w -= parseInt(getComputedCSSValue(el,'borderRightWidth'));*/
                            w -= parseInt(getComputedCSSValue(el,'paddingLeft'));
                            w -= parseInt(getComputedCSSValue(el,'paddingRight'));
                            return w + "px";
                        case "height": 
                            var w = el.clientHeight;
                            /*w -= parseInt(getComputedCSSValue(el,'borderTopWidth'));
                            w -= parseInt(getComputedCSSValue(el,'borderBottomWidth'));*/
                            w -= parseInt(getComputedCSSValue(el,'paddingTop'));
                            w -= parseInt(getComputedCSSValue(el,'paddingBottom'));
                            return w + "px";
                        case "top":
                            return el.offsetTop + "px";
                        case "left":
                            return el.offsetLeft + "px";
                        case "bottom":
                            return (el.parentNode.offsetHeight - (el.offsetTop+el.offsetHeight)) + "px";
                        case "right":
                            return (el.parentNode.offsetWidth - (el.offsetLeft+el.offsetWidth)) + "px";
                        case "margin":
                        case "marginTop":
                        case "marginLeft":
                        case "marginRight":
                        case "marginBottom":
                        case "padding":
                        case "paddingTop":
                        case "paddingLeft":
                        case "paddingRight":
                        case "paddingBottom":
                        case "minWidth":
                        case "minHeight":
                            return "0px";
                    }
                }
                value = value.replace(/\b([0-9.]+)(pc|pt|in|cm|mm|em|ex|%)/g, function(v) {
                    var val = parseFloat(v);
                    var unit = v.substr(val.toString().length);
                    if (unit == "%") {
                        var temp = percentToPx(val, el, prop) + "px";
                        if (temp) { return parseInt(temp) + "px"; }
                        return parseInt(val) + "%";
                    } else {
                        var f = window[unit + "ToPx"];
                        try {
                            return f(val, el, prop) + "px";
                        } catch (ex) {
                            return parseInt(val) + unit;
                        }
                    }
                });
                
                /* length constants */
                value = value.replace(/\bmedium\b/g, "3px");
                value = value.replace(/\bthin\b/g, "2px");
                value = value.replace(/\bthick\b/g, "5px");
                
                /* colors */
                if (/(C|c)olor/.test(prop)) {
                    for (c in HTMLColors) {
                        if (HTMLColors.hasOwnProperty(c)) {
                            value = value.replace(new RegExp("\\b" + c + "\\b","gi"), HTMLColors[c]);
                        }
                    }
                }
                
                return value;
            } else {
                switch (prop) {
                    case "border":
                        return (
                            getComputedCSSValue(el, "borderWidth") + " " +
                            getComputedCSSValue(el, "borderStyle") + " " +
                            getComputedCSSValue(el, "borderColor")
                        );
                    case "outline":
                        return (
                            getComputedCSSValue(el, "outlineWidth") + " " +
                            getComputedCSSValue(el, "outlineStyle") + " " +
                            getComputedCSSValue(el, "outlineColor")
                        );
                    case "background":
                        return (
                            getComputedCSSValue(el, "backgroundColor") + " " +
                            getComputedCSSValue(el, "backgroundImage") + " " +
                            getComputedCSSValue(el, "backgroundRepeat") + " " +
                            getComputedCSSValue(el, "backgroundAttachment") + " " +
                            getComputedCSSValue(el, "backgroundPosition")
                        );
                    case "backgroundPosition":
                        return (
                            getComputedCSSValue(el, "backgroundPositionX") + " " +
                            getComputedCSSValue(el, "backgroundPositionY")
                        );
                    case "overflow":
                        return getComputedCSSValue(el, "overflowX");
                    case "font":
                        return (
                            getComputedCSSValue(el, "fontStyle") + " " +
                            getComputedCSSValue(el, "fontVariant") + " " +
                            getComputedCSSValue(el, "fontWeight") + " " +
                            getComputedCSSValue(el, "fontSize") + " " +
                            getComputedCSSValue(el, "lineHeight") + " " +
                            getComputedCSSValue(el, "fontFamily")
                        );
                    case "layoutGrid":
                        return (
                            getComputedCSSValue(el, "layoutGridMode") + " " +
                            getComputedCSSValue(el, "layoutGridType") + " " +
                            getComputedCSSValue(el, "layoutGridLine") + " " +
                            getComputedCSSValue(el, "layoutGridChar")
                        );
                    case "listStyle":
                        return (
                            getComputedCSSValue(el, "listStyleType") + " " +
                            getComputedCSSValue(el, "listStylePostion") + " " +
                            getComputedCSSValue(el, "listStyleImage")
                        );
                }
            }
        }
    }
    
    /* Length units */
    round = Math.round;
    
    function pcToPx(value) {
        return ptToPx(12*value);
    }
    
    function ptToPx(value) {
        return inToPx(value / 72);
    }
    
    function inToPx(value) {
        return round(screen.deviceYDPI * value);
    }
    
    function cmToPx(value) {
        return inToPx(value/2.54);
    }
    
    function mmToPx(value) {
        return cmToPx(value/10);
    }
    
    function emToPx(value, el, prop) {
        var fontSize = 16;
        if (prop == "fontSize") {
            if (el.parentNode) {
                fontSize = getComputedCSSValue(el.parentNode, "fontSize");
            }
        } else {
            if (prop == "top" || prop == "left" || prop == "right" || prop == "bottom") {
                el = el.offsetParent || document.documentElement;
            }
            fontSize = getComputedCSSValue(el, "fontSize");
        }
        return round(parseInt(fontSize) * value);
    }

    function exToPx(value, el, prop) {
        return emToPx(0.5 * value, el, prop)
    }

    function percentToPx(value, el, prop) {
        var v = 0; el = el.offsetParent || document.documentElement;
        if ((/((w|W)idth)/.test(prop) && ! /((T|t)op|(B|b)ottom|Y\b)/.test(prop)) || /((L|l)eft|(R|r)ight|X\b)/.test(prop)) {
            v = el.offsetWidth;
        } else if ((/(H|h)eight/.test(prop)) || /((T|t)op|(B|b)ottom|Y\b)/.test(prop)) {
            v = el.offsetHeight;
        } else if (prop == "fontSize" || prop == "font") {
            v = getComputedCSSValue(el, "fontSize");
        } else { // If we don't know, we must leave %
            return false;
        }
        return round(parseInt(v)*value/100);
    }